package com.arkivanov.sample.shared.dialog

import androidx.compose.foundation.layout.widthIn
import androidx.compose.material.Text
import androidx.compose.material.TextButton
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import com.arkivanov.sample.shared.utils.AlertDialog

@Composable
fun DialogContent(dialogComponent: DialogComponent) {
    AlertDialog(
        onDismissRequest = {
            dialogComponent.onDismissClicked()
        },
        title = {
            Text(text = dialogComponent.title)
        },
        text = {
            Text(text = dialogComponent.message)
        },
        confirmButton = {
            TextButton(
                onClick = {
                    dialogComponent.onDismissClicked()
                }
            ) {
                Text("Dismiss")
            }
        },
        modifier = Modifier.widthIn(min = 200.dp),
    )
}
